package com.sencorsta.rabs.obj.ai.scene.task;

import cn.hutool.core.thread.ThreadUtil;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.sencorsta.rabs.annotation.SceneAnnotation;
import com.sencorsta.rabs.obj.ai.AiManage;
import com.sencorsta.rabs.obj.ai.api.BaseScene;
import com.sencorsta.rabs.obj.ai.api.Scene;
import com.sencorsta.rabs.util.ResettableData;
import org.opencv.core.Point;

import java.awt.AWTException;

/**
 * 角色信息
 */
@SceneAnnotation("SceneMain")
public class SceneMain_Task extends BaseScene implements Scene {
    @JsonIgnore
    @Override
    public float getPriority() {
        return 1.1f;
    }

    private static String PathEnter = System.getProperty("user.dir") + "\\opencv\\scene\\task\\enter.png";
    private static String PathCheck = System.getProperty("user.dir") + "\\opencv\\scene\\task\\check.png";
    private static String PathBack = System.getProperty("user.dir") + "\\opencv\\scene\\task\\back.png";
    private static String PathOb = System.getProperty("user.dir") + "\\opencv\\scene\\task\\ob.png";
    @Override
    public void back() throws AWTException {
        moveToClick(PathBack, AiManage.getInstance().getCheckPoint());
    }

    @Override
    public void open() throws AWTException {
        while (AiManage.getInstance().isRunning() && !check()) {
            AiManage.getInstance().updateWindow();
            ThreadUtil.sleep(2000);
            if (checkHas(PathEnter, AiManage.getInstance().getCheckPoint())) {
                moveToClick(PathEnter, AiManage.getInstance().getCheckPoint());
                continue;
            }
        }
    }

    @Override
    public boolean check() throws AWTException {
        if (checkHas(PathCheck, AiManage.getInstance().getCheckPoint())) {
            return true;
        }
        return false;
    }

    @Override
    public void think() throws AWTException {
        ThreadUtil.sleep(3000);


        moveToClick(PathOb, AiManage.getInstance().getCheckPoint());
        ThreadUtil.sleep(4000);

        randomToClick();
        ThreadUtil.sleep(2000);

        moveToClick(PathOb, AiManage.getInstance().getCheckPoint());
        ThreadUtil.sleep(4000);

        randomToClick();
        ThreadUtil.sleep(2000);

        getRecord().getData().setDone(true);
    }

    @Override
    public boolean isDone() {
        return getRecord().getData().isDone();
    }

    /**
     * 重置
     */
    @Override
    public ResettableData.ResetType getType(){
        return ResettableData.ResetType.HOUR_3;
    }

}
